/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: TRG_DTULTATU_PERIENTR                                                */
/*                                                                            */
/* Descrio:                                                                 */
/* Atualiza a data de ultima atualizao da periodicidade de entrega          */
/*                                                                            */
/* Criao:                                                                   */
/* 21/07/2000 - Joo Fernando dos Reis Corra                                 */
/*                                                                            */
/* Manutenes TRG :                                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PERIENTR'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER DTULTATU_PERIENTR
  GO

CREATE TRIGGER DTULTATU_PERIENTR
ON PERIENTR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PERIENTR', 'CDPERIENTR=' + CDPERIENTR+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PERIENTR
      SET DTULTATUPER = GETDATE()
      FROM INSERTED
      WHERE
       ISNULL(PERIENTR.CDPERIENTR,0) = ISNULL(INSERTED.CDPERIENTR,0);
   END;
END;
GO


